/* 
This work is licensed by the Creative Commons
Attribution-NonCommercial-ShareAlike 1.0

Key License Terms:
Attribution. The licensor permits others to copy, distribute, display, and perform the work. In return, licensees must give the original author credit.

Noncommercial. The licensor permits others to copy, distribute, display, and perform the work. In return, licensees may not use the work for commercial purposes -- unless they get the licensor's permission.

Share Alike. The licensor permits others to distribute derivative works under a license identical to the one that governs the licensor's work.

http://creativecommons.org/licenses/by-nc-sa/1.0

Visit http://www.blozom.com for commercial licensing terms.  
Copyright 2003, Uzilla LLC
*/


function blozomInvokePublish() {
	throbberBusy();
	var root = new Dir(blozomDataPath + "\\2003");
	blozomInitPublish();
	initMapObject();
	blozomMasterMap(root, blozomDataPath);
	//blozomPublishMonthlyArchives();
	blozomPublish();
	blozomPublishHomePage();
	throbberIdle();
}

function blozomMapFromPublish() {
	initMapObject();
	var rootFolder = new Dir(blozomDataPath);
	initMapObject();
	blozomMasterMap(rootFolder, blozomDataPath);
	 var objXMLSerializer = new XMLSerializer;
    var strXML = objXMLSerializer.serializeToString(xfmlRoot);
	//dump("master map is " + strXML + "\n");
	var mapFilePath = blozomDataPath + "\\map.xml";
	var mapFile = new File(mapFilePath);
	if(!mapFile.exists()) mapFile.create();
	mapFile.open("w",0644);
	mapFile.write(strXML);
	mapFile.close();
}

// Add userid to prefs
function blozomPingWeblogsDotCom() {
	document.getElementById("blozom-ping-frame").setAttribute("src",  "http://newhome.weblogs.com/pingSiteForm?name=" + escape(blozomSiteName)  + "&url=" + blozomRemotePath + blozomWebRoot);
}

/* Old template system
function blozomInitPublish() {
	// Read templates
	var headerPath = blozomDataPath + "\\templates\\header.txt" ;
	dump("Reading header " + headerPath + "\n");
	var fileObj = new File(headerPath,"r");
	dump("File exists?  " + fileObj.exists() + "\n");
	fileObj.open("r");
	header = fileObj.read();
	fileObj.close();
	dump("Reading footer\n");
	fileObj.initPath(blozomDataPath + "\\template\\footer.txt","r");
	dump("File exists?  " + fileObj.exists() + "\n");
	fileObj.open("r");
	footer = fileObj.read();
	fileObj.close();
}
*/

var moreContent = '';

var blozomMapObj = new Object();

function blozomMap(mapLocale, folder) {
	//dump("Mapping \n");
	var tempDirObj, newDirPath;
	//dump("\n\nMapping " + folder + "\n");
	var myDirPath = folder;
	var myDir = new Dir(myDirPath);
	var myDirArray = myDir.readDir();
	//dump("Looping over " + myDirArray.length + " dir elements \n");
	for(i in myDirArray) {
		//dump("map loop at i " + i + " " + myDirArray[i].path + "\n");
		if(myDirArray[i]) {
		//dump("Looking at " + i + " at " + myDirArray[i].path + " of type " + myDirArray[i].isDir() + "\n");
		if(myDirArray[i].isDir()) {
			
			if(blozomIsBlogFolder(myDirArray[i].path)) {
				//dump("Pubbing blog folder " + myDirArray[i].path + "\n");
				//dump("len is " + myDirArray[i].path.split("/").length + "\n");
				dump("Mapping regualr file " + myDirArray[i].path + "\n");
			
			}
			
			
			mapLocale[myDirArray[i].path] = new Object;
			if(blozomIsBlogFolder(myDirArray[i].path)) {
				mapLocale[myDirArray[i].path].blogFolder = true;
			}
			 //addDirectory(document.getElementById("blozom-tree-root"), myDirArray[i],i);
			blozomMap(mapLocale[myDirArray[i].path], myDirArray[i].path);
			
		}
		else {
			//dump("Mapping file " + myDirArray[i].path + "\n");
			if(myDirArray[i].isFile() || myDirArray.path.indexOf(".xml") == -1) {
				mapLocale[myDirArray[i].path] = new Object();	
					
				
			}
		}
	}
	}
 // dump("\nPopping recursion stack\n");
}


// Returns content for navigating among day's posts
function blogMap() {
	//for(i in blozomMapObj) dump("----" + i + "\n");
	var myContent = '';
	// TODO Loop over dataPath looking for blozomIsBlogFolder's
	var archives = blozomMapObj[blozomDataPath + blozomFileSeparator +"2003"];
	//for(i in archives) dump("====" + i + "\n");
	// Loop over months 
	for(month in archives) {
		dump("Month is " + month + "\n");
		if(archives[month].length) {
		myContent += '<span class="month"> Month:' + listLast(month) ;
		for(day in archives[month]) {
			//if(archives[month][day].length) {
			dump("day is " + archives[month][day] + "\n");

			myContent+= ' <a href="' + blozomWebRoot + '">Day:' + listLast(day) + '</a>';
			//}
		}
		myContent +="</span>";
		}
	}
	//dump("\n\n >>>>content is " + myContent + "\n");
	return myContent;
}
	
// ANTIQUATED? Yes
function blozomPublish() {
	dump("Initing publish \n");
	
	blozomMap(blozomMapObj, blozomDataPath);
	moreContent += blogMap();
	//blozomInitPublish();
	dump("Publishing \n");
	blozomPublishFolder(blozomDataPath);
	
}



// Recursively walks the blozomDataPath
// Calls blog or regular publish
function blozomPublishFolder(folder) {
	var tempDirObj, newDirPath, blogRegex;
	dump("\n\nPubbing " + folder + "\n");
	var myDirPath = folder;
	var myDir = new Dir(myDirPath);
	var myDirArray = myDir.readDir();
	for(i in myDirArray) {
		dump("Looking at " + i + " at " + myDirArray[i].path + " of type " + myDirArray[i].isDir() + "\n");
		if(myDirArray[i].isDir()) {
			dump("adding a directory\n");
			newDirPath = blozomPublishPathFromDataPath(myDirArray[i].path);
			
			tempDirObj = new Dir(newDirPath)
			if(!tempDirObj.exists()) {
				dump("Directory does not exist.");
				tempDirObj.create(0644);
			}			
			if(blozomIsBlogFolder(newDirPath) && isMonthFolder(newDirPath) ) {
				dump("Invoking monthly archives at " + myDirArray[i].path + "\n");
				blozomPublishMonthlyArchives( myDirArray[i].path);
			} else {
				if(blozomIsBlogFolder(newDirPath) && isDayFolder(newDirPath)) {
					blozomPublishFolderBlogStyle( myDirArray[i].path);
					//blozomPublishFolder(myDirArray[i].path);
				} else {
					blozomPublishFolder(myDirArray[i].path);
				}
			}
		}
		else {
			dump("Pubbing file " + myDirArray[i].path + "\n");
			if(myDirArray[i].isFile()) {
				blozomPublishFile(myDirArray[i]);
			}
		}
	}
  //dump("\nPopping recursion stack\n");
}




// Called for month folders
// Adding content for monthly archives
// and calling blozomPublishDayArchive for each day
function blozomPublishMonthlyArchives(monthPath) {
	dump("Invoked monthly archive with " + monthPath + "\n");
	var dayFolder;
	tempYear = getYearFromPath(monthPath)
	tempMonth = getMonthFromPath(monthPath);
	var monthDirectory = new Dir(monthPath);
	var monthContents = monthDirectory.readDir();
	dump("Read in " + monthContents.length + " days \n");
	for(var i=0; i<monthContents.length;i++) {
		dayFolder = monthContents[i];
		dump("  Looping over a month's entries " + tempMonth + " at " + dayFolder.path + " \n");
		if(dayFolder.isDir()) {
			dump("   Looping over day  "  + dayFolder.path + "\n");
			tempContent = blozomAggregateDay( dayFolder );
			myContent += tempContent;
			dump("    Invoking day archive \n");
			blozomPublishDayArchive(dayFolder, tempContent);
			tempContent = '';
		}
	}
	var renderPath = blozomPublishPath + blozomFileSeparator + tempYear + blozomFileSeparator + tempMonth + blozomFileSeparator + "index" + blozomFileExtension;
	dump("Rendering blog monthly archives page to " + renderPath  + " From month of " + tempMonth + "\n");
	//dump("Content is " + header + myContent + moreContent +  footer + "\n\n");
	var myFile = new File(renderPath);
	//blozomInsurePath(renderPath);
	if(!myFile.exists()) myFile.create();
 	myFile.open('w',0644);
	myFile.write(blozomHeaderBlob  + myContent + moreContent +  blozomFooterBlob );
	dump("wrote monthly archives to " + renderPath + "\n");
 	myFile.close();
	myContent = '';
}

function blozomPublishDayArchive(dayFolder, myContent){
	dump(">>>> Pubbing day archive for " + dayFolder.path + " with content " + myContent.length + "\n")
	var renderPath = blozomPublishPathFromDataPath(dayFolder.path) + "\\index" + blozomFileExtension; 
			//dump("writing day archives to " + renderPath + "\n");
	var myFile = new File(renderPath);
	
	//blozomInsurePath(renderPath);
	if(!myFile.exists()) {
		dump(" Creating day archive at " + renderPath + "\n");
		blozomInsurePath(renderPath);
		myFile.create();
	}
		 myFile.open('w',0644);
		 myFile.write(blozomHeaderBlob  + myContent + moreContent +  blozomFooterBlob );
		 //dump(" wrote day archives to " + renderPath + "\n");
		 myFile.close();

}


// ANTIQUATED
// Daily Archives
// TODO subroutine generation of day html
// use in monthly, daily, and homepage render
// In: myFolder -- Month Folder
function blozomPublishFolderBlogStyle(monthFolder) {
	var breadCrumbString = buildBreadCrumb(monthFolder)
	dump("\npublishing folder blog style " + monthFolder + "\n");
 	var contentFile, myContent, tempContent;
	var myDirPath = monthFolder;
	var myDir = new Dir(myDirPath);
	var myDirArray = myDir.readDir();
	dump("Looping over " + myDirArray.length + " dir elements \n");
	// TODO: change content file to dayFolder
	for(i in myDirArray) {
		dump("Looping over a day's entries at " + myDirArray[i].path + "\n");
		dump("Using aggreDay to add content  with " + myDirArray[i].isDir() + " \n");
		/* if(myDirArray[i].isDir()) { */
			
			myContent += blozomAggregateDay( myDirArray[i] ) + myContent;
			
		/*}*/
	}	
	var renderPath = blozomPublishPathFromDataPath(monthFolder); 
	renderPath = renderPath + blozomFileSeparator + "index" + blozomFileExtension;
	dump("[[[RENDER]]] Rendering blog page to " + renderPath + "\n\n");
	//dump("Content is \n" + myContent + "\n" + moreContent + "\n\n");
	var myFile = new File(renderPath);
	 myFile.open('w',0644);
	 myFile.write(blozomHeaderBlob + breadCrumbString + "<br/>" + myContent + moreContent +  blozomFooterBlob );
	 myFile.close();
	
}


function blozomPublishFile(contentFile) {
	var breadCrumbText = buildBreadCrumb(contentFile.path);
	//dump("in publish \n");
	contentFile.close();
	contentFile.open("r",0644);
	var content = contentFile.read();
	//dump("read content file \n");
	var renderPath = blozomPublishPathFromDataPath(contentFile.path);
	renderPath = renderPath.replace(".txt", blozomFileExtension);
	dump("----> Publishing to path " + renderPath + "\n");
	var myFile = new File(renderPath);
	blozomInsurePath(renderPath);
	if(!myFile.exists()) {
		dump("No file exists, creating \n");
		myFile.create();
	}
	//dump("Opening to write\n");
	 myFile.open('w',0644);
	 myFile.write(blozomHeaderBlob + breadCrumbText +  "<br/>" + content + moreContent +  blozomFooterBlob );
	 myFile.close();
}



// TODO Port the maintenance of publishing history
// to use of map.xml
function blozomPublishHomePage() {
	dump("Publishing home page \n");
	var arPath;
	var myContent = '';
	var tempNode;

	var tempFolder;
	var tempPath;
	var tempDay;
	var tempMonth;
	var tempYear;
	var daysPubbed = new Object;
	var publishPath = blozomPublishPath + '\\index' + blozomFileExtension;
	dump("Working file " + publishPath + "\n")

	//                      blozom node        blogs node
	root = xfmlRoot.childNodes.item(0).childNodes.item(1);
	dump("Publishing homepage " + root.nodeName + " " + root.childNodes.item(0).nodeName + "\n");
	var stopPost = root.childNodes.length - 10;
	if(stopPost < 0) stopPost = 0;
	
	for(var i = root.childNodes.length - 1; i >= stopPost; i=i-1) {
		//dump(" item node is " + root.childNodes.item(i).nodeName + "\n");
		tempNode = root.childNodes.item(i);
		tempPath = tempNode.getElementsByTagName("path").item(0).childNodes.item(0).nodeValue;
		
		// TODO Bundle-this
		//dump("data path is " + blozomDataPath + "\n");
		tempPath = tempPath.replace(blozomDataPath, "");
		//dump("Temp Path is " + tempPath + "\n");
		arPath = tempPath.split("\\");
		tempYear = arPath[1];
		tempMonth = arPath[2];
		tempDay = arPath[3];
		if(!daysPubbed[tempYear + tempMonth + tempDay]) {
		daysPubbed [tempYear + tempMonth + tempDay] = true;
		//myContent+= "<h2 class='dateHead'>" + tempDay + " - " + tempMonth + " - " + tempYear + "</h2>";
		//dump("temp day is " + tempDay + "," + tempMonth + " " + tempYear +  "\n");
		//dump("Looking for " + blozomDataPath + " path " + blozomFileSeparator + " sep " + tempYear +  " year" + blozomFileSeparator +  " month " + tempMonth + " sep " +  blozomFileSeparator + " day " + tempDay + "\n");
		var tempFolder = new Dir(blozomDataPath + blozomFileSeparator + tempYear + blozomFileSeparator + tempMonth + blozomFileSeparator + tempDay);
		//dump("Looking at " + tempFolder.path + "\n");
		// End Bundle-this
		try {
		myContent += blozomAggregateDay(tempFolder);
		} catch(e) {
			dump(">--- ERROR ---<\n PublishHomePage \n");
		}
		//for(j in tempNode) dump(j + " " + tempNode[j] + "\n");
		//blozomAggregateDay(
		}
	}

	var publishFile = new File(publishPath);
	dump("Writing " + publishFile.path + "\n");
	if(!publishFile.exists()) {
		publishFile.create();
		dump("Created publish file \n");
	}
	publishFile.open("w",0644);
	publishFile.write(blozomHeaderBlob +  myContent  +  blozomFooterBlob);
	publishFile.close();
}

function publishYearlyAndMonthlyArchives(strYear) {
	dump("xfml node is " + xfmlRoot + " " + xfmlRoot.nodeName + "\n" + xfmlRoot.childNodes.item(0).nodeName + "\n");
	var itemNode, title, permalink;
	var indexContent;
	//var indexMonthContent;
	var timingObj;
	var curMonth = '';
	var curDay = '';
	try {
		var blogNodes =  xfmlRoot.childNodes.item(0).childNodes.item(1);
		for(var i=1; i<blogNodes.childNodes.length;i++) {
			dump("pubbing item \n");
			itemNode = blogNodes.childNodes.item(i); 
			//dump("title is " + itemNode.childNodes.item(0).childNodes.item(0).nodeName + "\n");
			title = itemNode.childNodes.item(0).childNodes.item(0).nodeValue;
			permalink = itemNode.childNodes.item(2).childNodes.item(0).nodeValue;
			dump("Found " + title + " with " + permalink + "\n");		
			timingObj = getPostTimingFromPath(permalink);
			if(timingObj.month != curMonth) {
				curMonth = timingObj.month + '';
				indexContent += addIndexMonth(curMonth);
				curDay = '';
			}
			if(timingObj.day != curDay) {
				curDay = timingObj.day + '';
				indexContent += addIndexDay(curDay);
			}
			if(timingObj.year == strYear) indexContent += addIndexContent(title, permalink);		
		} 
	}
	catch (err) {
		dump("ERROR: " + err + "\n In year/month archive \n");
	}
	//dump(indexContent);
	var yearArchivePath = blozomPublishPath + blozomFileSeparator + strYear + blozomFileSeparator + "index" + blozomFileExtension;
	dump("Writing " + yearArchivePath + "\n");
	var yearArchiveFile = new File(yearArchivePath);
	if(!yearArchiveFile.exists()) yearArchiveFile.create();
	yearArchiveFile.open("w",0644);
	yearArchiveFile.write(blozomHeaderBlob + indexContent + blozomFooterBlob);
	yearArchiveFile.close();
}




/*<blozom><meta><mostrecentpost/></meta><blogs><item><title>Blogging Tools Roundup... Time to roll my own.</title><description/><guid isPermaLink="true">http://surfmind.com/musings/</guid><pubdate>1043681414846</pubdate><category>Blogging</category><a0:path xmlns:a0="http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul">D:\dev\muzings\2003\01\22\index.txt</a0:path></item> */
