// RENDER FUNCTION
// TODO move all renders to common locale

// For Monthly and Yearly Post Title Lists
function addIndexContent(title, permalink) {
	return '<div class="blogPointer"><a href="' + permalink + '">' + title + '</a></div>';
}

function addIndexDay(day) {
	return '<span class="postDay">' + day + '</span>';
	
}

function addIndexMonth(month) {
	return '<div class="postMonth">' + month + '</div>';
}

function buildBreadCrumb(strPath) {
	strPath = strPath.replace(blozomDataPath, "");
	
	var arPath = strPath.split("\\");
	var returnString = '<span class="dateHead">';
	returnString += '<a href="' + blozomWebRoot + '">Top</a> // ';
	var curWebPath = blozomWebRoot;
	for(var i=0;i<arPath.length-1;i++) {
		if(arPath[i].length) {
			//dump("adding " + arPath[i] + " breadcrumb \n");
			curWebPath += arPath[i] + "/";
			returnString += '<a href="' + curWebPath + '">';
			returnString += arPath[i];
			returnString += '</a>' + " // ";
		}
	}
	if(arPath.length > 0) {
	var filePath = arPath[arPath.length-1].replace(".txt", blozomFileExtension);
	//returnString = '<a href="' + curWebPath + "/" + filePath  + '">';
	returnString += filePath;
	//returnString += '</a>' + " // ";
	}
	return returnString + "</span>";
}

// TODO Separate data get from html write
function blozomAggregateDay(dayFolder) {
	dump("Aggregating day content at " + dayFolder.path + "\n")
	var myContent = '';
	var contentObj;
	/* var myDateComponents = dayFolder.path.replace(blozomDataPath, "").split(blozomFileSeparator);
	var pubYear = myDateComponents[1];
	var pubMonth = myDateComponents[2];
	var pubDay =  myDateComponents[3]; */
	
	var tempPath = dayFolder.path.replace(blozomDataPath, "");
	//dump("Temp Path is " + tempPath + "\n");
	arPath = tempPath.split("\\");
	tempYear = arPath[1];
	tempMonth = arPath[2];
	tempDay = arPath[3];
	myContent+= "<h2 class='dateHead'>" + tempDay + " - " + tempMonth + " - " + tempYear + "</h2>";
	
	var tempDate;
	var dayFiles = dayFolder.readDir();
	dump("%#%#%#%#%#%# Read directory in day aggregate of " + dayFolder.path + " and found " + dayFiles.length + ".");
	for (k in dayFiles) {
		contentFile = dayFiles[k];
		//dump("considering day file " + contentFile.path + ".");
		contentFile.open("r");
		tempContent = contentFile.read();
		dump("  " + contentFile.path  + " of " + tempContent.length+ " chars\n");
		contentFile.close();
		if(contentFile.path.indexOf(".xml") == -1) {	
			myContent += blozomItemHead;
			var contentObj= blozomMetaForPublish(contentFile.path.replace(".txt", ".xml"))

			myContent += "<a name='" + contentFile.path.replace(".xml","") + "'></a><h3>" + contentObj.title + "</h3>";
			
			myContent += tempContent;
			if(structCount(contentObj)){
			myContent +="<span style='float:right'>";
			myContent +="<a href=" + blozomRemotePath + blozomWebRoot  + tempYear + "/" + tempMonth + "/" + tempDay + "/index" + blozomFileExtension + "#" + listLast(dayFiles[k].path).replace(".txt","") + "><small>|||</small></a></span>";		
			// Put in pub date
			//dump("pub date is " + contentObj["pubdate"] + "\n");
			myContent += "<span class='blogDateAndCategory'>";
			if(contentObj["pubdate"] != 'undefined' && contentObj["pubdate"] != 'Invalid Date'  ) {
				
				if(blozomIsBlogFolder(contentObj["pubdate"])) {
					//dump("Millisecond date \n");
					tempDate = new Date(contentObj["pubdate"]);
					//tempDate.setTime();
				
				 myContent += "<br/>Posted at " + tempDate.getHours() + ":" + tempDate.getMinutes();
				} else {
					//dump("Good, GMT date \n");
					tempDate = new Date(contentObj["pubdate"]);
					//tempDate = Date.parse();
				 myContent += "<br/>Posted at " + tempDate.getHours() + ":" + tempDate.getMinutes();
				}
			}

			
			var numCategories = 0;
		
				for(i in contentObj.categories) {
					numCategories++;
					if(numCategories == 1) myContent +=  ", Published in: ";
					myContent+= " " + i;
				} 
			}
			myContent+= "</span>";
			
			myContent  += blozomItemTail ;
		}
	}
	dump( "returning day content of " + myContent.length + ".");
	return myContent;
}